unit DtMisc97;

(******************************************************************************
Misc. types and Constants for TDateEdit97

Author name=BOURMAD Mehdi
Author E-mail=bourmad@multimania.com
Author URL=www.multimania.com/bourmad
******************************************************************************)

interface

uses
  WinTypes, WinProcs, Classes, Dialogs, DsgnIntf, Graphics, Menus, SysUtils;

const
  IdsVersion = 'v4.6';

{Ressources franaises}
  IdsValAbout = '(a propos)';
  IdsValNone  = '(aucune)';
  ErrDateTooShort = 'Date trop courte';
  IdsFrom = 'Du';
  IdsTo   = 'Au';
  IdsDefaultDate = 'Initialiser date';


{English ressources}
{  IdsValAbout = '(about)';
  IdsValNone  = '(none)';
  ErrDateTooShort = 'Date too short';
  IdsFrom = 'From';
  IdsTo   = 'To';
  IdsDefaultDate = 'Set default date';}

{$IFDEF VER90}
  OBM_COMBO = 32738;
{$ENDIF}
{$IFDEF VER93}
  OBM_COMBO = 32738;
{$ENDIF}

  DaysPerMonth: array[1..12] of Integer =
    (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

type
  TNewMonthEvent = procedure(Sender: TObject;FromDate,TillDate:TDateTime) of Object; {tNotifyEvent}

  TDateOption = (doButtonTabStop, doCanClear, doCanPopup, doCanValidate,
                 doEmptyAsToday, doFocusOnError, doIsMasked, doIsModal,
                 doPopupToday, doShowCancel, doShowNumWeek, doShowToday);
  TDateOptions = set of TDateOption;
  TDateBtnStyle = (btsDropDown, btsCalendar);
  TCalendarButtons = (cbtNone, cbtPrevYear, cbtPrevMonth, cbtNextMonth, cbtNextYear);

  tDateObject = Class(tObject)
  private
  protected
  public
    Date : tDateTime;
    constructor Create;
    destructor Destroy; override;
  end;

{-------------------------------------------------------------}
{---------------------- TDayName -----------------------------}
{-------------------------------------------------------------}
  PTDateTime = ^TDateTime;
  TDay = string[2];
  PDayArray=^TDayArray;
  TDayArray = array[1..7] of TDay;
  TDayOfWeek = 1..7;
  TDayName = class(TGraphicsObject)
  private
    FMonday: TDay;
    FTuesday: TDay;
    FWednesday: TDay;
    FThursday: TDay;
    FFriday: TDay;
    FSaturday: TDay;
    FSunday: TDay;
  protected
    procedure SetMonday (Value : TDay);
    procedure SetTuesday (Value : TDay);
    procedure SetWednesday (Value : TDay);
    procedure SetThursday (Value : TDay);
    procedure SetFriday (Value : TDay);
    procedure SetSaturday (Value : TDay);
    procedure SetSunday (Value : TDay);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Assign(ASource: TPersistent); override;
  published
    property Monday: TDay read FMonday write SetMonday;
    property Tuesday: TDay read FTuesday write SetTuesday;
    property Wednesday: TDay read FWednesday write SetWednesday;
    property Thursday: TDay read FThursday write SetThursday;
    property Friday: TDay read FFriday write SetFriday;
    property Saturday: TDay read FSaturday write SetSaturday;
    property Sunday: TDay read FSunday write SetSunday;
  end;

{-------------------------------------------------------------}
{---------------------- TMonthName ---------------------------}
{-------------------------------------------------------------}
  TMonth = string[15];
  PMonthArray = ^TMonthArray;
  TMonthArray = array[1..12] of TMonth;
  TMonthName = class(TGraphicsObject)
  private
    FJanuary: TMonth;
    FFebruary: TMonth;
    FMarch: TMonth;
    FApril: TMonth;
    FMay: TMonth;
    FJune: TMonth;
    FJuly: TMonth;
    FAugust: TMonth;
    FSeptember: TMonth;
    FOctober: TMonth;
    FNovember: TMonth;
    FDecember: TMonth;
  protected
    procedure SetJanuary (Value : TMonth);
    procedure SetFebruary (Value : TMonth);
    procedure SetMarch (Value : TMonth);
    procedure SetApril (Value : TMonth);
    procedure SetMay (Value : TMonth);
    procedure SetJune (Value : TMonth);
    procedure SetJuly (Value : TMonth);
    procedure SetAugust (Value : TMonth);
    procedure SetSeptember (Value : TMonth);
    procedure SetOctober (Value : TMonth);
    procedure SetNovember (Value : TMonth);
    procedure SetDecember (Value : TMonth);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Assign(ASource: TPersistent); override;
  published
    property January: TMonth read FJanuary write SetJanuary;
    property February: TMonth read FFebruary write SetFebruary;
    property March: TMonth read FMarch write SetMarch;
    property April: TMonth read FApril write SetApril;
    property May: TMonth read FMay write SetMay;
    property June: TMonth read FJune write SetJune;
    property July: TMonth read FJuly write SetJuly;
    property August: TMonth read FAugust write SetAugust;
    property September: TMonth read FSeptember write SetSeptember;
    property October: TMonth read FOctober write SetOctober;
    property November: TMonth read FNovember write SetNovember;
    property December: TMonth read FDecember write SetDecember;
  end;

{-------------------------------------------------------------}
{------------------- TButtonsShortCut ------------------------}
{-------------------------------------------------------------}
  TButtonsShortCut = class(TPersistent)
  private
    FBtnClear: tShortCut;
    FBtnPopup: tShortCut;
    FBtnValidate: tShortCut;
  protected
  public
    constructor Create;
    destructor Destroy; override;
  published
    property BtnClear: tShortCut read FBtnClear write FBtnClear default scCtrl + Vk_Delete;
    property BtnPopup: tShortCut read FBtnPopup write FBtnPopup default scCtrl + Vk_Down;
    property BtnValidate: tShortCut read FBtnValidate write FBtnValidate default scCtrl + Vk_Return;
  end;

{-------------------------------------------------------------}
{------------------- TCalendarColors -------------------------}
{-------------------------------------------------------------}
  TCalendarColors = class(TGraphicsObject)
  private
    FColorArrow,
    FColorDates,
    FColorWeekEnd,
    FColorTitle,
    FColorValid : TColor;
  protected
    procedure SetColorArrow   (Value : TColor);
    procedure SetColorDates   (Value : TColor);
    procedure SetColorWeekend (Value : TColor);
    procedure SetColorTitle   (Value : TColor);
    procedure SetColorValid   (Value : TColor);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Assign(ASource: TPersistent); override;
  published
    property ColorArrow : tColor read FColorArrow write SetColorArrow default clBlack;
    property ColorDates : tColor read FColorDates write SetColorDates default clBlack;
    property ColorWeekEnd : tColor read FColorWeekEnd write SetColorWeekEnd default clRed;
    property ColorTitle : tColor read FColorTitle write SetColorTitle default clNavy;
    property ColorValid : TColor read FColorValid write SetColorValid default clMaroon;
  end;

  {*********** tAboutMeProperty ************}
  TAboutMeProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

implementation

constructor tDateObject.Create;
begin
  inherited Create;
end;

destructor tDateObject.Destroy;
begin
  inherited Destroy;
end;

{-------------------------------------------------------------}
{---------------------- TDayName -----------------------------}
{-------------------------------------------------------------}
constructor TDayName.Create;
begin
  inherited Create;
  FSunday := ShortDayNames[1];
  FMonday := ShortDayNames[2];
  FTuesday := ShortDayNames[3];
  FWednesday := ShortDayNames[4];
  FThursday := ShortDayNames[5];
  FFriday := ShortDayNames[6];
  FSaturday := ShortDayNames[7];
end;

destructor TDayName.Destroy;
begin
  inherited Destroy;
end;

procedure TDayName.Assign(ASource: TPersistent);
var
  Source: TDayName;
begin
{  inherited;}
  Source := ASource As TDayName;
  FSunday := Source.FSunday;
  FMonday := Source.FMonday;
  FTuesday := Source.FTuesday;
  FWednesday := Source.FWednesday;
  FThursday := Source.FThursday;
  FFriday := Source.FFriday;
  FSaturday := Source.FSaturday;
end;

procedure TDayName.SetMonday (Value : TDay);
begin
  if FMonday <> Value then
  begin
    FMonday := Value;
    Changed;
  end;
end;

procedure TDayName.SetTuesday (Value : TDay);
begin
  if FTuesday <> Value then
  begin
    FTuesday := Value;
    Changed;
  end;
end;

procedure TDayName.SetWednesday (Value : TDay);
begin
  if FWednesday <> Value then
  begin
    FWednesday := Value;
    Changed;
  end;
end;

procedure TDayName.SetThursday (Value : TDay);
begin
  if FThursday <> Value then
  begin
    FThursday := Value;
    Changed;
  end;
end;

procedure TDayName.SetFriday (Value : TDay);
begin
  if FFriday <> Value then
  begin
    FFriday := Value;
    Changed;
  end;
end;

procedure TDayName.SetSaturday (Value : TDay);
begin
  if FSaturday <> Value then
  begin
    FSaturday := Value;
    Changed;
  end;
end;

procedure TDayName.SetSunday (Value : TDay);
begin
  if FSunday <> Value then
  begin
    FSunday := Value;
    Changed;
  end;
end;

{-------------------------------------------------------------}
{---------------------- TMonthName ---------------------------}
{-------------------------------------------------------------}
constructor TMonthName.Create;
begin
  inherited Create;
  FJanuary := LongMonthNames[1];
  FFebruary := LongMonthNames[2];
  FMarch := LongMonthNames[3];
  FApril := LongMonthNames[4];
  FMay := LongMonthNames[5];
  FJune := LongMonthNames[6];
  FJuly := LongMonthNames[7];
  FAugust := LongMonthNames[8];
  FSeptember := LongMonthNames[9];
  FOctober := LongMonthNames[10];
  FNovember := LongMonthNames[11];
  FDecember := LongMonthNames[12];
end;

destructor TMonthName.Destroy;
begin
  inherited Destroy;
end;

procedure TMonthName.Assign(ASource: TPersistent);
var
  Source: TMonthName;
begin
{  inherited;}
  Source := ASource As TMonthName;
  FJanuary := Source.FJanuary;
  FFebruary := Source.FFebruary;
  FMarch := Source.FMarch;
  FApril := Source.FApril;
  FMay := Source.FMay;
  FJune := Source.FJune;
  FJuly := Source.FJuly;
  FAugust := Source.FAugust;
  FSeptember := Source.FSeptember;
  FOctober := Source.FOctober;
  FNovember := Source.FNovember;
  FDecember := Source.FDecember;
end;

procedure TMonthName.SetJanuary (Value : TMonth);
begin
  if FJanuary <> Value then
  begin
    FJanuary := Value;
    Changed;
  end;
end;

procedure TMonthName.SetFebruary (Value : TMonth);
begin
  if FFebruary <> Value then
  begin
    FFebruary := Value;
    Changed;
  end;
end;

procedure TMonthName.SetMarch (Value : TMonth);
begin
  if FMarch <> Value then
  begin
    FMarch := Value;
    Changed;
  end;
end;

procedure TMonthName.SetApril (Value : TMonth);
begin
  if FApril <> Value then
  begin
    FApril := Value;
    Changed;
  end;
end;

procedure TMonthName.SetMay (Value : TMonth);
begin
  if FMay <> Value then
  begin
    FMay := Value;
    Changed;
  end;
end;

procedure TMonthName.SetJune (Value : TMonth);
begin
  if FJune <> Value then
  begin
    FJune := Value;
    Changed;
  end;
end;

procedure TMonthName.SetJuly (Value : TMonth);
begin
  if FJuly <> Value then
  begin
    FJuly := Value;
    Changed;
  end;
end;

procedure TMonthName.SetAugust (Value : TMonth);
begin
  if FAugust <> Value then
  begin
    FAugust := Value;
    Changed;
  end;
end;

procedure TMonthName.SetSeptember (Value : TMonth);
begin
  if FSeptember <> Value then
  begin
    FSeptember := Value;
    Changed;
  end;
end;

procedure TMonthName.SetOctober (Value : TMonth);
begin
  if FOctober <> Value then
  begin
    FOctober := Value;
    Changed;
  end;
end;

procedure TMonthName.SetNovember (Value : TMonth);
begin
  if FNovember <> Value then
  begin
    FNovember := Value;
    Changed;
  end;
end;

procedure TMonthName.SetDecember (Value : TMonth);
begin
  if FDecember <> Value then
  begin
    FDecember := Value;
    Changed;
  end;
end;

{-------------------------------------------------------------}
{------------------- TButtonsShortCut ------------------------}
{-------------------------------------------------------------}
constructor TButtonsShortCut.Create;
begin
  inherited Create;
  FBtnClear := scCtrl + Vk_Delete;
  FBtnPopup := scCtrl + Vk_Down;
  FBtnValidate := scCtrl + Vk_Return;
end;

destructor TButtonsShortCut.Destroy;
begin
  inherited Destroy;
end;

{-------------------------------------------------------------}
{------------------- TCalendarColors -------------------------}
{-------------------------------------------------------------}
constructor TCalendarColors.Create;
begin
  inherited Create;
  FColorArrow := clBlack;
  FColorDates := clBlack;
  FColorWeekEnd := clRed;
  FColorTitle := clNavy;
  FColorValid := clBlue;
end;

destructor TCalendarColors.Destroy;
begin
  inherited Destroy;
end;

procedure TCalendarColors.Assign(ASource: TPersistent);
var
  Source: TCalendarColors;
begin
{  inherited;}
  Source := ASource As TCalendarColors;

  FColorArrow := Source.FColorArrow;
  FColorDates := Source.FColorDates;
  FColorWeekEnd := Source.FColorWeekEnd;
  FColorTitle := Source.FColorTitle;
  FColorValid := Source.FColorValid;
end;

procedure TCalendarColors.SetColorArrow(value : TColor);
begin
  if FColorArrow <> Value then
  begin
    FColorArrow := Value;
    Changed;
  end;
end;

procedure TCalendarColors.SetColorDates(value : TColor);
begin
  if FColorDates <> Value then
  begin
    FColorDates := Value;
    Changed;
  end;
end;

procedure TCalendarColors.SetColorWeekEnd(value : TColor);
begin
  if FColorWeekEnd <> Value then
  begin
    FColorWeekEnd := Value;
    Changed;
  end;
end;

procedure TCalendarColors.SetColortitle(value : TColor);
begin
  if FColorTitle <> Value then
  begin
    FColorTitle := Value;
    Changed;
  end;
end;

procedure TCalendarColors.SetColorValid(value : TColor);
begin
  if FColorValid <> Value then
  begin
    FColorValid := Value;
    Changed;
  end;
end;

{************************* tAboutMeProperty component *************************}
procedure TAboutMeProperty.Edit;
begin
  MessageDlg ('tDatePack97 components '+IdsVersion
              +#13#10'These components are freeware.'
              +#13#10' 1998-1999 BOURMAD Mehdi'
              +#13#10'http://www.multimania.com/bourmad'
              +#13#10'mailto:bourmad@multimania.com',
              mtInformation,
              [mbOk], 0);
end;

function TAboutMeProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog, paReadOnly]
                                    - [paSubProperties];
end;

function TAboutMeProperty.GetValue: string;
begin
  Result := IdsValAbout;
end;

end.
